<template>
  <q-card v-if="node.aspects" flat class="q-pb-sm">
    <q-card-section class="text-primary text-weight-bold detail__heading q-mb-sm">
      Aspects
      <div class="detail__close">
        <q-icon name="close" @click="close_detail" class="cursor-pointer" title="Verberg dit scherm"/>
      </div>
    </q-card-section>
    <table class="q-ml-md q-mt-sm aspects">
      <thead>
        <tr>
          <th>aspect type</th>
          <th>axis</th>
          <th>value</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(aspect, index) in node.aspects" :key="index">
          <td>{{aspect.type}}</td>
          <td>{{aspect.axis}}</td>
          <td>{{aspect.value}}</td>
        </tr>
      </tbody>
    </table>
  </q-card>
  <q-card v-if="node.concept" flat class="q-pb-md" role="region" aria-label="Gedetailleerde view">
    <q-card-section class="text-primary text-weight-bold detail__heading q-mb-lg" role="heading">
      Details
      <div class="detail__close" v-if="!node.aspects">
        <q-icon name="close" @click="close_detail" class="cursor-pointer" title="Verberg dit scherm"/>
      </div>
    </q-card-section>

    <table class="q-ml-md q-mt-sm q-mb-sm">
      <tr>
        <td class="label">Naam:</td>
        <td>{{ node.concept.name }}</td>
      </tr>
      <tr>
        <td class="label" role="rowheader">Abstract:</td>
        <td>{{ node.concept.abstract }}</td>
      </tr>
      <tr>
        <td class="label" role="rowheader">Balans:</td>
        <td>{{ node.concept.balance }}</td>
      </tr>
      <tr>
        <td class="label" role="rowheader">Nillable:</td>
        <td>{{ node.concept.nillable }}</td>
      </tr>
      <tr>
        <td class="label" role="rowheader">Periodtype:</td>
        <td>{{ node.concept.periodtype }}</td>
      </tr>
      <tr>
        <td class="label" role="rowheader">Namespace prefix:</td>
        <td>{{ node.concept.ns_prefix }}</td>
      </tr>
      <tr>
        <td class="label" role="rowheader">Namespace:</td>
        <td>{{ node.concept.namespace }}</td>
      </tr>
      <tr>
        <td class="label" role="rowheader">Substitution group:</td>
        <td>{{ node.concept.substitution_group }}</td>
      </tr>
      <tr v-if="node.concept.typed_domainref">
        <td class="label" role="rowheader">Typed domainRef:</td>
        <td>{{ node.concept.typed_domainref }}</td>
      </tr>
    </table>
    <div class="table_head q-ml-md text-weight-bold" role="heading">Itemtype</div>
    <ItemTypeQuickview v-if="node.concept" :itemtype="node.concept.itemtype" class="q-ml-md"></ItemTypeQuickview>
    <div class="table_head q-ml-md text-weight-bold" role="heading">Labels</div>
    <LabelTable :labels="node.concept.labels" class="q-ma-md q-mb-sm"></LabelTable>
    <template v-if="node.concept.references && node.concept.references.length > 0">
      <div class="table_head q-ml-md text-weight-bold">Referenties</div>
      <table class="q-ma-md q-mb-md reference_table" role="region" aria-label="Referenties">
        <tr v-for="(reference,index) of node.concept.references" :key="index">
          <td>
            <div><span class="text-bold">{{ reference.name }}</span> {{ showReference(reference) }}</div>
            <div class="q-pa-xs text-caption small_id">{{ reference.id }}</div>
          </td>
        </tr>
      </table>
    </template>

  </q-card>
  <div v-else>
    not a concept
  </div>
  <template v-if="node.aspect">
    <q-item-label>Aspect:</q-item-label>
  </template>
  <template v-if="node.dimension">
    <q-item-label>Dimension:</q-item-label>
  </template>
  <template v-if="node.rulenode">
    <q-item-label>Rulenode:</q-item-label>
  </template>
</template>

<script>
import SharedMethods from "components/SharedMethods";
import LabelTable from "components/LabelTable";
import ItemTypeQuickview from "components/ItemTypeQuickview";

export default {
  name: "CellValue",
  components: {ItemTypeQuickview, LabelTable},
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
  },
  props: {
    node: Object
  },
  methods: {
    close_detail: function () {
      this.$emit("close_detail")
    },
    showReference: function (reference) {
      /*
       * extracts the relevant parts of the reference, excluding name,id and label
       */
      let result = ''
      Object.keys(reference).forEach(function (key) {
        if (['name', 'label', 'id'].indexOf(key) === -1) {
          if (reference[key]) {
            result += key + ': ' + reference[key] + ' ';
          }
        }
      })
      return result
    },

  },
  emits: ["close_detail"]
}
</script>

<style scoped lang="scss">
.detail__close {
  float: right;
}

.detail__heading {
  border-bottom: 1px solid $primary;
  font-size: 20px;
}

.table_head {
  border-bottom: 1px solid $primary;
  margin-top: 5px;
}

.label {
  font-weight: bold;
  vertical-align: top;
}

.separator {
  margin-top: 115px;
  border-top: black 1px solid;
}

.reference_table tr:nth-child(odd) {
  background-color: $blue-grey-1;
}

.reference_table .small_id {
  text-align: right;
  font-style: italic;
}

table {
  border-collapse: collapse;
}

td {
  border: 1px solid $secondary;
  padding: 1px 5px;
}

.aspects tbody tr:nth-child(odd) {
  background-color: $blue-grey-1;
}

</style>
